/**
 * RichEditView.h
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#if !defined(AFX_RICHEDITVIEW_H__346F2A02_18DE_418A_B490_DFD54C68E2A2__INCLUDED_)
#define AFX_RICHEDITVIEW_H__346F2A02_18DE_418A_B490_DFD54C68E2A2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRichEditView : public CWindowImpl<CRichEditView, CRichEditCtrl>  
{
public:
  DECLARE_WND_SUPERCLASS(NULL, CRichEditCtrl::GetWndClassName())
  BOOL PreTranslateMessage(MSG* pMsg){
    return FALSE;
  }

private:
  CFont m_font;

  // bZ[W}bv
  BEGIN_MSG_MAP_EX(CRichEditView)
    MSG_WM_CREATE(OnCreate)
//    MSG_WM_CONTEXTMENU(OnContextMenu)
//    COMMAND_ID_HANDLER_EX(ID_MENUITEM_DEFAULT, OnMenuDefault)
//    COMMAND_ID_HANDLER_EX(ID_MENUITEM_EMPHASIS, OnMenuEmphasis)
  END_MSG_MAP()

  LRESULT OnCreate(LPCREATESTRUCT lpcs){
    LRESULT lRet = DefWindowProc();

    // tHgݒ
    m_font.CreatePointFont(100, _T("lr SVbN"));
    SetFont(m_font);

    SetTextMode(TM_PLAINTEXT);
    SetTextMode(TM_MULTILEVELUNDO);

    DWORD dwEvent = GetEventMask(); //SendMessage(EM_GETEVENTMASK, 0, 0);
    dwEvent |= ENM_CHANGE;
    SetEventMask(dwEvent); //SendMessage(EM_SETEVENTMASK, 0, (LPARAM)dwEvent);

    return lRet;
  }

};

#endif // !defined(AFX_RICHEDITVIEW_H__346F2A02_18DE_418A_B490_DFD54C68E2A2__INCLUDED_)
