/**
 * xml2pdf.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/*
 * Usage
 * cscript.exe xml2pdf.js -wm 480 -hm 680 -tp a4j -tc 11pt -td jarticle -tm -pp a4 -c -o output_filename [input_filename]
 * -wm 摜̍ő剡
 * -hm 摜̍ő卂
 * -tp TeXŏۂ̗pTCY
 * -tc TeXŏۂ̃ftHg̃tHgTCY
 * -td TeXŏۂ̃hLgNX
 * -tm 2ig
 * -pp dvi2pdfmxŏۂ̗pTCY
 * -c Ōɒԃt@C폜
 * -o o̓t@C
 */

// LaTeX̊ϐݒ肷邳̊ƂȂtH_̎w
// {texbasepath}/bin tH_TeX̎st@CQ
// {texbasepath}/share tH_TeXsharet@CQƂāAplatex.exeĂяoB
var texbasepath = "C:/usr/local";

// IvVڏݒ
var option = new Object();

// LaTeXpϐ
option.tex_paper_size = "a4j"; // texŏp̃TCY
option.tex_character_size = "11pt"; // texŏftHg̃tHgTCY
option.tex_document_class = "jsarticle"; // texŎgphLgNX
option.tex_columns = 1; // ̒l2ɂƁA{2igɂȂ

// 摜̍őTCY(P pix)
option.wmax = 400;
option.hmax = 680;

// pdf𐶐ۂɎgppTCY
option.dvipdfmx_paper_size = "a4";

// Ōɒԃt@C폜邩ǂi0:Ȃ 1:j
option.cleanup = 0;

// o̓t@C
option.output_filename = "-";

// ̓t@C
option.input_filename = "-";

// IvVځ@܂

// ̑O[oϐ
var fs = new ActiveXObject("Scripting.FileSystemObject");
var xmldoc = new ActiveXObject("Msxml2.DOMDocument");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;
var ForReading = 1;
var ForWriting = 2;

// [eBeBt@Cݒ
var getimagesize = fs.GetFile(WScript.ScriptFullName).ParentFolder + "\\getimagesize.exe";

texbasepath = fs.GetFolder(texbasepath).ShortPath;
do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var dzo = new Object();
  var tso;
  
  xmldoc.async = false;
  xmldoc.resolveExternals = false;
  xmldoc.preserveWhiteSpace = true;

  { // R}hC
    for (var i = 0; i < objArgs.length; ++i) {
      if (objArgs(i) == "-wm") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-wm.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.wmax = parseInt(objArgs(i));
        if (isNaN(option.wmax)) {
          WScript.StdErr.Write("-wm.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
      } else if (objArgs(i) == "-hm") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-hm.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.hmax = parseInt(objArgs(i));
        if (isNaN(option.hmax)) {
          WScript.StdErr.Write("-hm.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
      } else if (objArgs(i) == "-tp") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-tp.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.tex_paper_size = objArgs(i);
      } else if (objArgs(i) == "-tc") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-tc.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.tex_character_size = objArgs(i);
      } else if (objArgs(i) == "-td") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-td.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.tex_document_class = objArgs(i);
      } else if (objArgs(i) == "-tm") {
        option.tex_columns = 2;
      } else if (objArgs(i) == "-pp") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-pp.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.dvipdfmx_paper_size = objArgs(i);
      } else if (objArgs(i) == "-c") {
        option.cleanup = 1;
      } else if (objArgs(i) == "-o") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-o.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.output_filename = objArgs(i);
      } else {
        if (i + 1 != objArgs.length) {
          WScript.StdErr.Write(objArgs(i) + ".\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.input_filename = objArgs(i);
      }
    }
  }

  if (option.output_filename == "-") {
    WScript.StdErr.Write("no output file assigned.\n");
    WScript.Quit(-1);
  }
  
  // o̓t@C쐬
  if (option.output_filename != "-") {
    var tso;
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch (e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
    tso.Close();
  }

  // t@Cǂݍ
  {
    var srcArr = new Array();
    if (option.input_filename != "-") {
      var tsi;
      try {
        tsi = fs.OpenTextFile(option.input_filename, ForReading);
      } catch (e) {
        WScript.StdErr.Write(option.input_filename + "\n");
        WScript.StdErr.Write("failed to open input file.\n");
        WScript.Quit(-1);
      }
      while (!tsi.AtEndOfStream) {
        srcArr.push(tsi.ReadLine());
      }
      tsi.Close();
    } else {
      while (!WScript.StdIn.AtEndOfStream) {
        srcArr.push(WScript.StdIn.ReadLine());
      }
    }
    xmldoc.loadXML(srcArr.join(""));
  }

  var strdst = xml2string(xmldoc);

  // text@Ci[tH_̒Zt@C擾
  var basepath = new String(fs.GetFile(option.output_filename).ParentFolder.ShortPath);

  //  ̃JgtH_ۑ
  var curold = sh.CurrentDirectory;
  
  // ZtH_chdir
  sh.CurrentDirectory = fs.GetFolder(basepath);

  // texo̓t@Co
  var texfilenamebase = fs.GetBaseName(option.output_filename);
  
  try {
    tso = fs.OpenTextFile(texfilenamebase + ".tex", ForWriting, true);
  } catch (e) {
    WScript.StdErr.Write("failed to open output tex file.\n");
    WScript.Quit(-1);
  }
  tso.Write(strdst);
  tso.Close();
  
  // texԃt@C폜 aux dvi log out toc
  delete_files(texfilenamebase, "aux dvi log out toc pdf");

  // tex̓ɕKvȊϐݒ
  var env = sh.Environment("Process");
  var strenv = env("PATH");
  env("PATH") = texbasepath + "/bin;" + strenv;
  env("TEXMFMAIN") = texbasepath + "/share/texmf";
  env("TEXMFCNF") = texbasepath + "/share/texmf/web2c";

  // 3tex
  var ret = 0;
  ret = sh.Run("platex " + texfilenamebase, 10, true);
  if (ret != 0) {
    WScript.StdErr.Write("TeX process failed with code " + ret + " at time 1.\n");
    WScript.Quit(-1);
  }
  ret = sh.Run("platex " + texfilenamebase, 10, true);
  if (ret != 0) {
    WScript.StdErr.Write("TeX process failed with code " + ret + " at time 2.\n");
    WScript.Quit(-1);
  }
  ret = sh.Run("platex " + texfilenamebase, 10, true);
  if (ret != 0) {
    WScript.StdErr.Write("TeX process failed with code " + ret + " at time 3.\n");
    WScript.Quit(-1);
  }
  
  // dvipdfmx
  ret = sh.Run("dvipdfmx -p " + option.dvipdfmx_paper_size + " -o \"" + option.output_filename + "\" " + texfilenamebase, 10, true);
  if (ret != 0) {
    WScript.StdErr.Write("dvipdfmx failed with code " + ret + ".\n");
    WScript.Quit(-1);
  }

  if (option.cleanup) {
    // ԃt@C폜 aux dvi log out toc
    delete_files(texfilenamebase, "tex aux dvi log out toc");
  }
  sh.CurrentDirectory = curold;
  
  // C[`I
  return 0;
}

var xmlgv;

function delete_files(base, exts) {
  var extlist = exts.split(" ");
  for (var i = 0; i < extlist.length; ++i) {
    if (fs.FileExists(base + "." + extlist[i])) {
      fs.DeleteFile(base + "." + extlist[i]);
    }
  }
  return 0;
}

function xml2string(xmldoc) {
  var strarr = new Array();
  var objNodeList;
  xmlgv = new Object();
  xmlgv.hlevel = 0;

  strarr.push("\\documentclass[" + option.tex_paper_size + "," + option.tex_character_size + "]{" + option.tex_document_class + "}\n");
  strarr.push("\\usepackage[dvipdfm,bookmarks=true,bookmarksnumbered=false,bookmarkstype=toc]{hyperref}\n");
  strarr.push("\\AtBeginDvi{\\special{pdf:tounicode 90ms-RKSJ-UCS2}}\n");
  strarr.push("\\usepackage[dvipdfmx]{graphicx}\n");
  strarr.push("%\\usepackage{fancyhdr}\n");
  strarr.push("%\\pagestyle{fancy}\n");
  strarr.push("%\\usepackage[addtotoc]{abstract}\n");
  strarr.push("%\\lhead{}\n");

  strarr.push("\\setcounter{tocdepth}{3}\n");
  strarr.push("\\setcounter{secnumdepth}{-1}\n");
  strarr.push("\\setlength{\\columnsep}{3zw}\n");
  strarr.push("\\setlength{\\columnseprule}{0.4pt}\n");

  strarr.push("%\\renewcommand{\\headrulewidth}{0.4pt}\n");
  strarr.push("%\\renewcommand{\\footrulewidth}{0.4pt}\n");
  strarr.push("\\def\\yen{Y\\llap=}\n");
  strarr.push("\\newcommand{\\ruby}[2]{%\n");
  strarr.push("\\leavevmode\n");
  strarr.push("\\setbox0=\\hbox{#1}%\n");
  strarr.push("\\setbox1=\\hbox{\\tiny #2}%\n");
  strarr.push("\\ifdim\\wd0>\\wd1 \\dimen0=\\wd0 \\else \\dimen0=\\wd1 \\fi\n");
  strarr.push("\\hbox{%\n");
  strarr.push("\\kanjiskip=0pt plus 2fil\n");
  strarr.push("\\xkanjiskip=0pt plus 2fil\n");
  strarr.push("\\vbox{%\n");
  strarr.push("\\hbox to \\dimen0{%\n");
  strarr.push("\\tiny \\hfil#2\\hfil}%\n");
  strarr.push("\\nointerlineskip\n");
  strarr.push("\\hbox to \\dimen0{\\mathstrut\\hfil#1\\hfil}}}}\n");

  strarr.push("\\begin{document}\n");

  var istitle = 0;
  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    strarr.push("\\title{" + escape_specialchars(objNodeList.item(0).getAttribute("param0")) + "}\n");
    istitle = 1;
  }
  objNodeList = xmldoc.getElementsByTagName("author");
  if (objNodeList.length > 0) {
    strarr.push("\\author{" + escape_specialchars(objNodeList.item(0).getAttribute("param0")) + "}\n");
    istitle = 1;
  }
  objNodeList = xmldoc.getElementsByTagName("date");
  if (objNodeList.length > 0) {
    strarr.push("\\date{" + escape_specialchars(objNodeList.item(0).getAttribute("param0")) + "}\n");
    istitle = 1;
  }
  if (istitle != 0) {
    strarr.push("\\maketitle\n");
    strarr.push("\\clearpage\n");
  }
  strarr.push("\\tableofcontents\n");
  if (option.tex_columns == 1) {
    strarr.push("\\clearpage\n");
  } else {
    strarr.push("\\twocolumn\n");
  }

  parse_xmlnode(strarr, xmldoc.documentElement);

  strarr.push("\\end{document}\n");

  return strarr.join("");
}

function parse_xmlnode(strarr, xmlnode) {
  var nl = xmlnode.childNodes;
  var str = "";

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 1) {
      var strclass = nd.getAttribute("class");
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.hlevel++;
        strarr.push("");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("");
        xmlgv.hlevel--;
      } else if (nd.nodeName == "heading") {
        var strheading = "";
        switch (xmlgv.hlevel) {
        case 1:
          strheading = "section";
          break;
        case 2:
          strheading = "subsection";
          break;
        case 3:
          strheading = "subsubsection";
          break;
        case 4:
          strheading = "paragraph";
          break;
        case 5:
          strheading = "subparagraph";
          break;
        case 6:
          strheading = "subsubparagraph";
          break;
        }
        strarr.push("\\" + strheading + "{");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("}");
      } else if (nd.nodeName == "list") {
        strarr.push("\\begin{itemize}");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("\\end{itemize}");
      } else if (nd.nodeName == "litem") {
        strarr.push("\\item ");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("");
      } else if (nd.nodeName == "blockquote") {
        strarr.push("\\begin{quotation}");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("\\end{quotation}");
      } else if (nd.nodeName == "blockquote_inner") {
        strarr.push("\\par\n");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("");
      } else if (nd.nodeName == "dlist") {
        strarr.push("\\begin{description}");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("\\end{description}");
      } else if (nd.nodeName == "dterm") {
        strarr.push("\\item[");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("] ");
      } else if (nd.nodeName == "ddesc") {
        strarr.push("\\par\n");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("");
      } else if (nd.nodeName == "paragraph") {
        strarr.push("\\par\n");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("\n");
      } else if (nd.nodeName == "div") {
        strarr.push("\n");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("\n");
      } else if (nd.nodeName == "ruby") {
        strarr.push("\\ruby{");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("}{" + nd.getAttribute("param0") + "}");
      } else if (nd.nodeName == "em") {
        strarr.push("\\emph{");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("}");
      } else if (nd.nodeName == "link") {
        strarr.push("\\href{\"" + nd.getAttribute("param0") + "\"}{");
        strarr.push(parse_xmlnode(strarr, nd));
        strarr.push("}");
      } else if (nd.nodeName == "image") {
        // param0t@Cparam1LvV擾
        var filename = nd.getAttribute("param0");
        var ffilename = fs.GetParentFolderName(fs.GetAbsolutePathName(option.output_filename)) + "/" + filename;
        var caption = nd.getAttribute("param1");
        
        // 摜TCY擾[eBeBN
        var sh = new ActiveXObject("WScript.Shell");
        var cmdline = getimagesize + " \"" + ffilename + "\"";
        var objExec = sh.Exec(cmdline);
        var w = -1, h = -1;
        if (!objExec.StdOut.AtEndOfStream) {
          w = parseInt(objExec.StdOut.ReadLine());
        }
        if (!objExec.StdOut.AtEndOfStream) {
          h = parseInt(objExec.StdOut.ReadLine());
        }
        // Kvɉĉ摜k
        strarr.push("\\begin{figure*}[htbp]\n");
        strarr.push("\\begin{center}\n");
        strarr.push("\\includegraphics");
        // ȂƂ96dpi͊mۂ̂ŁAi1inch=72.27ptj400pxȉ̏ꍇ͊gEkȂ
        // 400pxȏ゠邢͏c680pxȏ͏k
        if ((w == -1) || (h == -1)) {
          // 摜f[^擾s\
        } else {
          if ((w < option.wmax) && (h < option.hmax)) { // kȂAPʕϊ̂
            w = w * 3 / 4;
            h = h * 3 / 4;
          } else if (h < option.hmax) { // ͂ݏo
            h = h * (option.wmax * 3 / 4) / w;
            w = option.wmax * 3 / 4;
          } else if (w < option.wmax) { // c͂ݏo
            w = w * (option.hmax * 3 / 4) / h;
            h = option.hmax * 3 / 4;
          } else { // cƂ͂ݏo 
            if (w * option.hmax > option.wmax * h) { // w:h > wmax:h Ȃ킿ւ̂͂ݏo傫ꍇʕɂȂ悤ɏk
              h = h * (option.wmax * 3 / 4) / w;
              w = option.wmax * 3 / 4;
            } else {
              w = w * (option.hmax * 3 / 4) / h;
              h = option.hmax * 3 / 4;
            }
          }
          strarr.push("[bb = 0 0 " + w + "pt " + h + "pt" + "]");
        }
        strarr.push("{" + nd.getAttribute("param0") + "}\n");
        strarr.push("\\caption{" + nd.getAttribute("param1") + "}\n");
        strarr.push("\\end{center}\n");
        strarr.push("\\end{figure*}\n");
      } else {
        // `^O
      }
    } else if (nd.nodeType == 3) { // TEXT_NODE
      strarr.push(escape_specialchars(nl.item(i).text));
    }
  }
  return str;
}

function escape_specialchars(str1) {
  var str2 = new String();
  for (var i0 = 0; i0 < str1.length; i0++) {
    var c = str1.charAt(i0);
    if (c == "\\") {
      str2 += "{\\yen}";
    } else if (c == " ") {
      str2 += "~";
    } else if (c == "^") {
      str2 += "{\\textasciicorcum}";
    } else if (c == "~") {
      str2 += "{\\textasciitilde}";
    } else if (c == "|") {
      str2 += "{\\textbar}";
    } else if (c == "<") {
      str2 += "{\\textless}";
    } else if (c == ">") {
      str2 += "{\\textgreater}";
    } else if ("#$%&_{}".indexOf(c) > -1) {
      str2 += "{\\" + c + "}";
    } else {
      str2 += c;
    }
  }
  return str2;
}
