/**
 * xml2xhtml.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/*
 * Usage
 * cscript.exe xml2xhtml.js -w 480 -c "default.css" -i 2 -o output_filename [input_filename]
 * -w 摜̍ő剡
 * -c csst@C
 * -i ʏ㕔ɍ쐬ڎ̌oxi0:oȂ 1:匩o 2:o 3:oj
 * -o o̓t@C
 */


// IvVڏݒ
var option = new Object();

// 摜̍ő剡iP pixj
option.wmax = 480;

// gpcsst@CicsstH_IAt@Cɂꍇ͏㏑Ȃj
option.cssfile = "default.css";

// ʏ㕔ɍ쐬ڎ̌oxi0:oȂ 1:匩o 2:o 3:oj
option.indexlevel = 0;

// o̓t@C
option.output_filename = "-";

// ̓t@C
option.input_filename = "-";

// IvVځ@܂


// O[oϐ
var fs = new ActiveXObject("Scripting.FileSystemObject");
var xmldoc = new ActiveXObject("Msxml2.DOMDocument");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;
var ForReading = 1;
var ForWriting = 2;


// [eBeBt@Cݒ
var getimagesize = fs.GetFile(WScript.ScriptFullName).ParentFolder + "\\getimagesize.exe";

do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var tso;
  var xmlgv = new Object();
  
  xmldoc.async = false;
  xmldoc.resolveExternals = false;
  xmldoc.preserveWhiteSpace = true;

  
  { // R}hC
    for (var i = 0; i < objArgs.length; ++i) {
      if (objArgs(i) == "-w") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-w.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.wmax = parseInt(objArgs(i));
        if (isNaN(option.wmax)) {
          WScript.StdErr.Write("-w.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
      } else if (objArgs(i) == "-c") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-c.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.cssfile = objArgs(i);
      } else if (objArgs(i) == "-i") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-i.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.indexlevel = objArgs(i);
      } else if (objArgs(i) == "-o") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-o.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.output_filename = objArgs(i);
      } else {
        if (i + 1 != objArgs.length) {
          WScript.StdErr.Write(objArgs(i) + ".\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.input_filename = objArgs(i);
      }
    }
  }

  // o̓t@C쐬
  if (option.output_filename != "-") {
    var tso;
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch (e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
    tso.Close();
  }

  // t@Cǂݍ
  {
    var srcArr = new Array();
    if (option.input_filename != "-") {
      var tsi;
      try {
        tsi = fs.OpenTextFile(option.input_filename, ForReading);
      } catch (e) {
        WScript.StdErr.Write("failed to open input file.\n");
        WScript.Quit(-1);
      }
      while (!tsi.AtEndOfStream) {
        srcArr.push(tsi.ReadLine());
      }
      tsi.Close();
    } else {
      while (!WScript.StdIn.AtEndOfStream) {
        srcArr.push(WScript.StdIn.ReadLine());
      }
    }
    xmldoc.loadXML(srcArr.join(""));
  }

  var strdst = xml2string(xmldoc, xmlgv);

  // t@Co
  tso = WScript.StdOut;
  if (option.output_filename != "-") {
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch(e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
  }
  tso.Write(strdst);
  if (option.output_filename != "-") {
    tso.Close();
  }

  // Kvɉcsst@CRs[
  if (option.output_filename != "-") {
    var workdir = fs.GetFile(option.output_filename).ParentFolder;
    var cssdir = fs.GetFile(WScript.ScriptFullName).ParentFolder.ParentFolder + "\\css";
    if (!fs.FileExists(workdir + "\\" + option.cssfile)) {
      if (fs.FileExists(cssdir + "\\" + option.cssfile)) {
        fs.CopyFile(cssdir + "\\" + option.cssfile, workdir + "\\" + option.cssfile, false);
      }
    }
  }

  // C[`I
  return 0;
}


function xml2string(xmldoc, xmlgv) {
  var strarr = new Array();
  var objNodeList;
  xmlgv = new Object();
  xmlgv.hlevel = 0;
  
  strarr.push("<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
  strarr.push("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
  strarr.push(" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
  strarr.push("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">\n");
  strarr.push("<head>\n");
  strarr.push("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\" />\n");
  strarr.push("<title>");
  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    strarr.push(objNodeList.item(0).getAttribute("param0"));
  } else {
    strarr.push("untitled document");
  }
  strarr.push("</title>\n");
  strarr.push("<link rel=\"stylesheet\" type=\"text/css\" href=\"" + option.cssfile + "\" />\n");
  strarr.push("</head>\n");
  strarr.push("<body>\n");
  strarr.push("<div class=\"ground_sheet\">\n");
  strarr.push("<div class=\"content\">\n");
  objNodeList = xmldoc.getElementsByTagName("date");
  if (objNodeList.length > 0) {
    strarr.push("<div class=\"date\">" + objNodeList.item(0).getAttribute("param0") + "</div>\n");
  }
  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    xmlgv.hlevel++;
    strarr.push("<div class=\"section_1\">\n");
    strarr.push("<h1>" + objNodeList.item(0).getAttribute("param0") + "</h1>\n");
  } else {
    xmlgv.hlevel++;
    strarr.push("<div class=\"section_1\">\n");
    strarr.push("<h1>Untitled Document</h1>\n");
  }

  if (option.indexlevel > 0) {
    xmlgv.count = 0;
    strarr.push("<div class=\"index\">\n");
    strarr.push("<h2>ڎ</h2>\n");
    strarr.push("<ul>\n");
    parse_xmlnode_for_index(xmldoc.documentElement, strarr, xmlgv);
    strarr.push("</ul>\n");
    strarr.push("</div>\n");
  }
  xmlgv.count = 0;
  parse_xmlnode(xmldoc.documentElement, strarr, xmlgv);

  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    strarr.push("</div>\n");
  }
  objNodeList = xmldoc.getElementsByTagName("author");
  if (objNodeList.length > 0) {
    strarr.push("<div class=\"author\">" + objNodeList.item(0).getAttribute("param0") + "</div>\n");
  }
  strarr.push("</div>\n</div>\n</body>\n</html>\n");

  return strarr.join("");
}

function parse_xmlnode_for_text(xmlnode, strarr) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 3) { // TEXT NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/&/g, "&amp");
      str1 = str1.replace(/</g, "&lt;");
      str1 = str1.replace(/>/g, "&gt;");
      str1 = str1.replace(/ /g, "&nbsp;");
      strarr.push(str1);
    }
  }
  return 0;
}

function parse_xmlnode_for_index(xmlnode, strarr, xmlgv) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 1) { // Element
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.hlevel++;
        xmlgv.count++;
        if (xmlgv.hlevel < option.indexlevel + 2) {
          var strheading = "section";
          var objNodeList = nd.getElementsByTagName("heading");
          if (objNodeList.length > 0) {
            var strheadingarr = new Array();
            parse_xmlnode_for_text(objNodeList.item(0), strheadingarr, xmlgv);
            strheading = strheadingarr.join("");
          }
          
          if ((strid) && (strid != "")) {
          } else {
            strid = "section_" + xmlgv.count;
          }
          
          strarr.push("<li><a href=\"#" + strid +"\">" + strheading + "</a>");
          var objNodeList = nd.getElementsByTagName("section");
          if (objNodeList.length > 0) {
            strarr.push("<ul>\n");
            parse_xmlnode_for_index(nd, strarr, xmlgv);
            strarr.push("</ul>\n");
          }
          strarr.push("</li>");
        } else {
          // xmlgv.counti߂
          parse_xmlnode_for_index(nd, strarr, xmlgv);
        }
        xmlgv.hlevel--;
      }
    }
  }
  return 0;
}

function parse_xmlnode(xmlnode, strarr, xmlgv) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) {
      var strclass = nd.getAttribute("class");
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.hlevel++;
        xmlgv.count++;
        if ((!strclass) || (strclass == "")) strclass = "section_" + xmlgv.hlevel;
        str += "<div class=\"" + strclass + "\"";
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        } else {
          str += " id=\"section_" + xmlgv.count + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</div>");
        xmlgv.hlevel--;
      } else if (nd.nodeName == "heading") {
        strarr.push("<h" + xmlgv.hlevel + ">");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</h" + xmlgv.hlevel + ">");
      } else if (nd.nodeName == "list") {
        str += "<ul";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</ul>");
      } else if (nd.nodeName == "litem") {
        strarr.push("<li>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</li>");
      } else if (nd.nodeName == "blockquote") {
        str += "<blockquote";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</blockquote>");
      } else if (nd.nodeName == "blockquote_inner") {
        strarr.push("<p>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</p>");
      } else if (nd.nodeName == "dlist") {
        str += "<dl";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</dl>");
      } else if (nd.nodeName == "dterm") {
        strarr.push("<dt>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</dt>");
      } else if (nd.nodeName == "ddesc") {
        strarr.push("<dd>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</dd>");
      } else if (nd.nodeName == "paragraph") {
        strarr.push("<p>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</p>");
      } else if (nd.nodeName == "div") {
        str += "<div";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</div>");
      } else if (nd.nodeName == "div_inner") {
        strarr.push("<div>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</div>");
      } else if (nd.nodeName == "ruby") {
        strarr.push("<ruby><rb>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</rb><rp>(</rp><rt>" + nd.getAttribute("param0") + "</rt><rp>)</rp></ruby>");
      } else if (nd.nodeName == "em") {
        strarr.push("<em>");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</em>");
      } else if (nd.nodeName == "a") {
        strarr.push("<a id=\"" + strid + "\">");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "link") {
        strarr.push("<a href=\"" + nd.getAttribute("param0") + "\">");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "rlink") {
        strarr.push("<a href=\"#" + nd.getAttribute("param0") + "\">");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "image") {
        // param0t@Cparam1LvV擾
        var filename = nd.getAttribute("param0");
        var ffilename = fs.GetParentFolderName(fs.GetAbsolutePathName(option.output_filename)) + "/" + filename;
        var caption = nd.getAttribute("param1");
        
        // 摜TCY擾[eBeBN
        var cmdline = getimagesize + " \"" + ffilename + "\"";
        var objExec = sh.Exec(cmdline);
        var w = -1, h = -1;
        if (!objExec.StdOut.AtEndOfStream) {
          w = parseInt(objExec.StdOut.ReadLine());
        }
        if (!objExec.StdOut.AtEndOfStream) {
          h = parseInt(objExec.StdOut.ReadLine());
        }

        // Kvɉĉ摜k
        if (w < option.wmax) { // kȂ
        } else {
          h = parseInt(h * option.wmax / w);
          w = option.wmax;
        }
        str += "<div><a href=\"" + filename + "\"><img ";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += " src=\"" + filename + "\"";
        if ((h > -1) && (w > -1)) {
          str += " width=\"" + w + "\"";
          str += " height=\"" + h + "\"";
        }
        str += " alt=\"" + nd.getAttribute("param1") + "\"";
        str += " /></a></div>";
        strarr.push(str);
      } else if (nd.nodeName == "hr") {
        str = "<hr";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += "/>";
        strarr.push(str);
      } else {
        // `^O
      }
    } else if (nd.nodeType == 3) { // TEXT_NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/&/g, "&amp;");
      str1 = str1.replace(/</g, "&lt;");
      str1 = str1.replace(/>/g, "&gt;");
      str1 = str1.replace(/ /g, "&nbsp;");
      strarr.push(str1);
    }
  }
  return 0;
}
