/**
 * xml2xhtml_multi.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/*
 * Usage
 * cscript.exe xml2xhtml_multi.js -w 480 -c "default.css" --ci "default.css" -n -m -o output_filename [input_filename]
 * -w 摜̍ő剡
 * -c csst@C
 * -ci indexy[Wcsst@C
 * -n irQ[V
 * -m HTMLwv쐬
 * -o o̓t@C
 */


// [U[
var htmlhelp_hhc = "C:\\Program Files\\HTML Help Workshop\\hhc.exe";


// IvVڏݒ
var option = new Object();

// 摜̍ő剡iP pixj
option.wmax = 480;

// ey[WɑOAڎAƂirQ[V邩i0:Ȃ 1:j
option.navigation = 0;

// htmlwvpɒ邩i0:Ȃ 1:j
option.htmlhelp = 0;

// gpcsst@CicsstH_IAt@Cɂꍇ͏㏑Ȃj
option.cssfile = "default.css";

// ڎʂɎgpcsst@C
option.cssfile_index = "default.css";

// o̓t@C
option.output_filename = "-";

// ̓t@C
option.input_filename = "-";

// IvVځ@܂


// O[oϐ
var fs = new ActiveXObject("Scripting.FileSystemObject");
var xmldoc = new ActiveXObject("Msxml2.DomDocument");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;
var ForReading = 1;
var ForWriting = 2;

// [eBeBt@Cݒ
var getimagesize = fs.GetFile(WScript.ScriptFullName).ParentFolder + "\\getimagesize.exe";

var document_title = "dzformat document";
var document_author = "";
var docmuent_date = "";

do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var tso;
  var xmlgv = new Object();

  xmlgv.xmlidsection = new Array();

  xmldoc.async = false;
  xmldoc.resolveExternals = false;
  xmldoc.preserveWhiteSpace = true;

  { // R}hC
    for (var i = 0; i < objArgs.length; ++i) {
      if (objArgs(i) == "-w") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-w.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.wmax = parseInt(objArgs(i));
        if (isNaN(option.wmax)) {
          WScript.StdErr.Write("-w.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
      } else if (objArgs(i) == "-c") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-c.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.cssfile = objArgs(i);
      } else if (objArgs(i) == "-ci") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-ci.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.cssfile_index = objArgs(i);
      } else if (objArgs(i) == "-i") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-i.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.indexlevel = objArgs(i);
      } else if (objArgs(i) == "-n") {
        option.navigation = 1;
      } else if (objArgs(i) == "-m") {
        option.htmlhelp = 1;
      } else if (objArgs(i) == "-o") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-o.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.output_filename = objArgs(i);
      } else {
        if (i + 1 != objArgs.length) {
          WScript.StdErr.Write(objArgs(i) + ".\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.input_filename = objArgs(i);
      }
    }
  }

  // o̓t@C쐬
  if (option.output_filename == "-") {
    WScript.StdErr.Write("No output file assigned.\n");
    WScript.Quit(-1);
  }

  {
    var tso;
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch (e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
    tso.Close();
  }

  if (option.navigation && option.htmlhelp) {
    WScript.StdErr.Write("invalid option convination.\n");
    WScript.Quit(-1);
  }

  if (option.htmlhelp) {
    if (option.putput_filename == "-") {
      WScript.StdErr.Write("invalid option convination.\n");
      WScript.Quit(-1);
    }
    check_files_for_htmlhelp();
  }

  // t@Cǂݍ
  {
    var srcArr = new Array();
    if (option.input_filename != "-") {
      var tsi;
      try {
        tsi = fs.OpenTextFile(option.input_filename, ForReading);
      } catch (e) {
        WScript.StdErr.Write("failed to open input file.\n");
        WScript.Quit(-1);
      }
      while (!tsi.AtEndOfStream) {
        srcArr.push(tsi.ReadLine());
      }
      tsi.Close();
    } else {
      while (!WScript.StdIn.AtEndOfStream) {
        srcArr.push(WScript.StdIn.ReadLine());
      }
    }
    xmldoc.loadXML(srcArr.join(""));
  }

  // ڎHTML
  generate_index(xmldoc, xmlgv);

  // KvȂHTML HELP쐬邽߂̃t@C
  if (option.htmlhelp) {
    generate_toc(xmldoc, xmlgv);
  }

  // HTML
  xmlgv.hlevel = 1;
  xmlgv.section_max = xmlgv.section;
  xmlgv.section = 0;
  xmlgv.count = 0;
  xmlgv.section_count = 0;
  strarr = [];
  parse_xmlnode_for_section(xmldoc.documentElement, strarr, xmlgv);

  // Kvɉcsst@CRs[
  if (option.output_filename != "-") {
    var workdir = fs.GetFile(option.output_filename).ParentFolder;
    var cssdir = fs.GetFile(WScript.ScriptFullName).ParentFolder.ParentFolder + "\\css";
    if (!fs.FileExists(workdir + "\\" + option.cssfile)) {
      if (fs.FileExists(cssdir + "\\" + option.cssfile)) {
        fs.CopyFile(cssdir + "\\" + option.cssfile, workdir + "\\" + option.cssfile, false);
      }
    }
    if (!fs.FileExists(workdir + "\\" + option.cssfile_index)) {
      if (fs.FileExists(cssdir + "\\" + option.cssfile_index)) {
        fs.CopyFile(cssdir + "\\" + option.cssfile_index, workdir + "\\" + option.cssfile_index, false);
      }
    }
  }

  if (option.htmlhelp) {
    sh.Run("\"" + htmlhelp_hhc + "\" \"" + fs.GetFile(option.output_filename).ParentFolder + "\\\\" + fs.GetBaseName(option.output_filename) + ".hhp\"", 1, true);
  }

  // C[`I
  return 0;
}

function check_files_for_htmlhelp() {

  // cssfile͂Ă邩
  var workdir = fs.GetFile(option.output_filename).ParentFolder;
  var cssdir = fs.GetFile(WScript.ScriptFullName).ParentFolder.ParentFolder + "\\css";
  if (!fs.FileExists(workdir + "\\" + option.cssfile)) {
    if (!fs.FileExists(cssdir + "\\" + option.cssfile)) {
      WScript.StdErr.Write("cannot find css files.\n");
      WScript.Quit(-1);
    }
  }
  if (!fs.FileExists(workdir + "\\" + option.cssfile_index)) {
    if (!fs.FileExists(cssdir + "\\" + option.cssfile_index)) {
      WScript.StdErr.Write("cannot find css files.\n");
      WScript.Quit(-1);
    }
  }

  // hhc.exe͂邩
  if (!fs.FileExists(htmlhelp_hhc)) {
    WScript.StdErr.Write("cannot find HTML Help Workshop.\n");
    WScript.Quit(-1);
  }
  return;
}

/*
 * ڎHTMLIDtڂ̃XgAbv
 *
 */
function generate_index(xmldoc, xmlgv) {
  var strarr = new Array();
  var objNodeList;
  xmlgv.hlevel = 0;
  xmlgv.section = 0;
  xmlgv.count = 0;

  // ڎt@CAIDڈꗗ擾
  strarr.push("<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
  strarr.push("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
  strarr.push(" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
  strarr.push("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">\n");
  strarr.push("<head>\n");
  strarr.push("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\" />\n");
  strarr.push("<title>");
  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    document_title = objNodeList.item(0).getAttribute("param0");
  }
  strarr.push(document_title);
  strarr.push("</title>\n");
  strarr.push("<link rel=\"stylesheet\" type=\"text/css\" href=\"" + option.cssfile_index + "\" />\n");
  strarr.push("</head>\n");
  strarr.push("<body>\n");
  strarr.push("<div class=\"ground_sheet\">\n");
  strarr.push("<div class=\"content\">\n");
  objNodeList = xmldoc.getElementsByTagName("date");
  if (objNodeList.length > 0) {
    document_date = objNodeList.item(0).getAttribute("param0");
    strarr.push("<div class=\"date\">" + document_date + "</div>\n");
  }

  xmlgv.hlevel++;
  strarr.push("<div class=\"section_1\">");
  strarr.push("<h1>" + document_title + "</h1>\n");

  parse_xmlnode_for_index(xmldoc.documentElement, strarr, xmlgv);

  strarr.push("</div>\n");

  objNodeList = xmldoc.getElementsByTagName("author");
  if (objNodeList.length > 0) {
    document_author = objNodeList.item(0).getAttribute("param0");
    strarr.push("<div class=\"author\">" + document_author + "</div>\n");
  }

  strarr.push("</div>\n</div>\n</body>\n</html>\n");

  // o̓t@CI[v(HTMLwv쐬̏ꍇ͌ォRpCč쐬̂ŁAł͉Ȃ)
  if (!option.htmlhelp) {
    var tso;
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch(e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
    tso.Write(strarr.join(""));
    tso.Close();
  }
}

function parse_xmlnode_for_index(xmlnode, strarr, xmlgv) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) { // Element
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.hlevel++;
        xmlgv.count++;
        var strheading = "section";
        var objNodeList = nd.getElementsByTagName("heading");
        if (objNodeList.length > 0) {
          var strheadingarr = new Array();
          var xmlgv1 = new Object();
          xmlgv1.hlevel = 0;
          xmlgv1.section = 0;
          xmlgv1.count = 0;
          parse_xmlnode_for_text(objNodeList.item(0), strheadingarr, xmlgv1);
          strheading = strheadingarr.join("");
        }
        
        if ((strid) && (strid != "")) {
          // id ꍇidXgɓo^Ahlevel == 2̏ꍇ̓t@CzăXg1ZĂ
          if (xmlgv.hlevel == 2) {
            xmlgv.xmlidsection[strid] = xmlgv.section + 1;
          } else {
            xmlgv.xmlidsection[strid] = xmlgv.section;
          }
        } else {
          strid = "section_" + xmlgv.count;
        }
        
        if (xmlgv.hlevel == 2) {
          xmlgv.section++;
          strarr.push("<p>\n");
          strarr.push("<h2>" + xmlgv.section + ". <a href=\"section_" + xmlgv.section + ".html\">" + strheading + "</a></h2>\n");
          // child section΁AqXg쐬
          var objNodeList = nd.getElementsByTagName("section");
          if (objNodeList.length > 0) {
            strarr.push("<ol>\n");
            parse_xmlnode_for_index(nd, strarr, xmlgv);
            strarr.push("</ol>\n");
          }
          strarr.push("</p>\n");
        } else {
          strarr.push("<li><a href=\"section_" + xmlgv.section + ".html#" + strid +"\">" + strheading + "</a>");
          var objNodeList = nd.getElementsByTagName("section");
          if (objNodeList.length > 0) {
            strarr.push("<ol>\n");
            parse_xmlnode_for_index(nd, strarr, xmlgv);
            strarr.push("</ol>\n");
          }
          strarr.push("</li>");
        }
        xmlgv.hlevel--;
      } else {
        if ((strid) && (strid != "")) {
          xmlgv.xmlidsection[strid] = xmlgv.section;
        }
      }
    }
  }
  return 0;
}

function generate_toc(xmldoc, xmlgv) {
  var strarr = new Array();
  var strfiles = new Array();
  var objNodeList;
  xmlgv.hlevel = 0;
  xmlgv.section = 0;
  xmlgv.count = 0;

  // ڎt@CAIDڈꗗ擾
  strarr.push("<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n");
  strarr.push("<HTML>\n");
  strarr.push("<HEAD>\n");
  strarr.push("<meta name=\"GENERATOR\" content=\"dzformatter\">\n");
  strarr.push("<!-- Sitemap 1.0 -->\n");
  strarr.push("</HEAD><BODY>\n");
  strarr.push("<OBJECT type=\"text/site properties\">\n");
  strarr.push("<param name=\"ImageType\" value=\"Folder\">\n");
  strarr.push("</OBJECT>\n");
  strarr.push("<UL>\n");
  xmlgv.hlevel++;
  parse_xmlnode_for_toc(xmldoc.documentElement, strarr, strfiles, xmlgv);
  strarr.push("</UL>\n");
  strarr.push("</BODY></HTML>\n");

  // o̓t@CI[v
  var tso;
  var filenamebase = fs.GetFile(option.output_filename).ParentFolder + "\\" + fs.GetBaseName(option.output_filename);
  try {
    tso = fs.OpenTextFile(filenamebase + ".hhc", ForWriting, true);
  } catch(e) {
    WScript.StdErr.Write("failed to open output file.\n");
    WScript.Quit(-1);
  }
  tso.Write(strarr.join(""));
  tso.Close();

  try {
    tso = fs.OpenTextFile(filenamebase + ".hhp", ForWriting, true);
  } catch(e) {
    WScript.StdErr.Write("failed to open output file.\n");
    WScript.Quit(-1);
  }
  tso.Write("[OPTIONS]\n");
  tso.Write("Contents file=" + filenamebase + ".hhc\n");
  tso.Write("Compiled file=" + option.output_filename + "\n");
  tso.Write("\n");
  tso.Write("[FILES]\n");
  tso.Write(strfiles.join("\n"));
  tso.Write("\n");
  tso.Close();
}

function parse_xmlnode_for_text(xmlnode, strarr) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 3) { // TEXT NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/&/g, "&amp");
      str1 = str1.replace(/</g, "&lt;");
      str1 = str1.replace(/>/g, "&gt;");
      str1 = str1.replace(/ /g, "&nbsp;");
      strarr.push(str1);
    }
  }
  return 0;
}

function parse_xmlnode_for_toc(xmlnode, strarr, strfiles, xmlgv) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) { // Element
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.hlevel++;
        xmlgv.count++;
        var strheading = "section";
        var objNodeList = nd.getElementsByTagName("heading");
        if (objNodeList.length > 0) {
          var strheadingarr = new Array();
          var xmlgv1 = new Object();
          xmlgv1.hlevel = 0;
          xmlgv1.section = 0;
          xmlgv1.count = 0;
          parse_xmlnode_for_text_raw(objNodeList.item(0), strheadingarr, xmlgv1);
          strheading = strheadingarr.join("");
        }
        
        if ((strid) && (strid != "")) {
          // id ꍇidXgɓo^Ahlevel == 2̏ꍇ̓t@CzăXg1ZĂ
          if (xmlgv.hlevel == 2) {
            xmlgv.xmlidsection[strid] = xmlgv.section + 1;
          } else {
            xmlgv.xmlidsection[strid] = xmlgv.section;
          }
        } else {
          strid = "section_" + xmlgv.count;
        }
        
        if (xmlgv.hlevel == 2) {
          xmlgv.section++;
          strfiles.push("section_" + xmlgv.section + ".html");
          strarr.push("<LI> <OBJECT type=\"text/sitemap\">\n");
          strarr.push("<param name=\"Name\" value=\"" + strheading + "\">\n");
          strarr.push("<param name=\"Local\" value=\"section_" + xmlgv.section + ".html\">\n");
          strarr.push("</OBJECT>\n");
          var objNodeList = nd.getElementsByTagName("section");
          if (objNodeList.length > 0) {
            strarr.push("<UL>\n");
            parse_xmlnode_for_toc(nd, strarr, strfiles, xmlgv);
            strarr.push("</UL>\n");
          }
        } else if (xmlgv.hlevel == 3) {
          strarr.push("<LI> <OBJECT type=\"text/sitemap\">\n");
          strarr.push("<param name=\"Name\" value=\"" + strheading + "\">\n");
          strarr.push("<param name=\"Local\" value=\"section_" + xmlgv.section + ".html#" + strid + "\">\n");
          strarr.push("</OBJECT>\n");
          if (objNodeList.length > 0) {
            parse_xmlnode_for_toc(nd, strarr, strfiles, xmlgv);
          }
        } else {
          if (objNodeList.length > 0) {
            parse_xmlnode_for_toc(nd, strarr, strfiles, xmlgv);
          }
        }
        xmlgv.hlevel--;
      } else {
        if ((strid) && (strid != "")) {
          xmlgv.xmlidsection[strid] = xmlgv.section;
        }
      }
    }
  }
  return 0;
}

function parse_xmlnode_for_text_raw(xmlnode, strarr) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 3) { // TEXT NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/\"/g, "\\\"");
      str1 = str1.replace(/\\/g, "\\\\");
      strarr.push(str1);
    }
  }
  return 0;
}

function save_strarr_section(xmlnode, strarr, xmlgv) {
  var tso;
  var filename = fs.GetFile(option.output_filename).ParentFolder + "\\section_" + xmlgv.section_count + ".html";
  try {
    tso = fs.OpenTextFile(filename, ForWriting, true);
  } catch(e) {
    WScript.StdErr.Write("failed to open output file.\n");
    WScript.Quit(-1);
  }
  var strnavigation = "<div class=\"navigation\">";
  if (xmlgv.section_count > 1) {
    strnavigation += "<a href=\"section_" + (xmlgv.section_count - 1) + ".html\">&lt;&lt;O</a> ";
  } else {
    strnavigation += "&lt;&lt;O ";
  }
  strnavigation += "<a href=\"" + fs.GetFileName(option.output) + "\">ڎ</a> ";
  if (xmlgv.section_count < xmlgv.section_max) {
    strnavigation += "<a href=\"section_" + (xmlgv.section_count + 1) + ".html\">&gt;&gt;</a> ";
  } else {
    strnavigation += "&gt&gt";
  }
  strnavigation += "</div>\n";

  var strarr1 = new Array();
  if (option.htmlhelp == 0) {
    strarr1.push("<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
  }
  strarr1.push("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
  strarr1.push(" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
  strarr1.push("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">\n");
  strarr1.push("<head>\n");
  strarr1.push("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\" />\n");
  strarr1.push("<title>");
  strarr1.push(document_title + " - SECTION " + xmlgv.section_count);
  strarr1.push("</title>\n");
  strarr1.push("<link rel=\"stylesheet\" type=\"text/css\" href=\"" + option.cssfile + "\" />\n");
  strarr1.push("</head>\n");
  strarr1.push("<body>\n");
  strarr1.push("<div class=\"ground_sheet\">\n");
  strarr1.push("<div class=\"content\">\n");
  if (option.navigation) strarr1.push(strnavigation);
  strarr1.push("<div class=\"section_1\">\n");
  if (document_date.length > 0) {
    strarr1.push("<div class=\"date\">" + document_date + "</div>\n");
  }

  var strarr2 = new Array();
  if (option.navigation) strarr2.push(strnavigation);
  strarr2.push("</div>\n");
  if (document_author.length > 0) {
    strarr2.push("<div class=\"author\">" + document_author + "</div>\n");
  }
  strarr2.push("</div>\n</div>\n</body>\n</html>\n");
  
  tso.Write(strarr1.join(""));
  tso.Write(strarr.join(""));
  tso.Write(strarr2.join(""));
  tso.Close();
}

function parse_xmlnode_for_section(xmlnode, strarr, xmlgv) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) {
      var strclass = nd.getAttribute("class");
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        xmlgv.count++;
        if (xmlgv.hlevel == 1) {
          strarr = [];
          xmlgv.section_count++;
          xmlgv.heading = "SECTION " + xmlgv.section_count;
        }
        xmlgv.hlevel++;
        if ((!strclass) || (strclass == "")) strclass = "section_" + xmlgv.hlevel;
        str += "<div class=\"" + strclass + "\"";
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        } else {
          str += " id=\"section_" + xmlgv.count + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</div>");
        xmlgv.hlevel--;
        if (xmlgv.hlevel == 1) {
          save_strarr_section(xmlnode, strarr, xmlgv);
        }
      } else if (nd.nodeName == "heading") {
        strarr.push("<h" + (xmlgv.hlevel - 1) + ">");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</h" + (xmlgv.hlevel - 1) + ">");
      } else if (nd.nodeName == "list") {
        str += "<ul";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</ul>");
      } else if (nd.nodeName == "litem") {
        strarr.push("<li>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</li>");
      } else if (nd.nodeName == "blockquote") {
        str += "<blockquote";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</blockquote>");
      } else if (nd.nodeName == "blockquote_inner") {
        strarr.push("<p>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</p>");
      } else if (nd.nodeName == "dlist") {
        str += "<dl";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</dl>");
      } else if (nd.nodeName == "dterm") {
        strarr.push("<dt>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</dt>");
      } else if (nd.nodeName == "ddesc") {
        strarr.push("<dd>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</dd>");
      } else if (nd.nodeName == "paragraph") {
        strarr.push("<p>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</p>");
      } else if (nd.nodeName == "div") {
        str += "<div";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += ">";
        strarr.push(str);
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</div>");
      } else if (nd.nodeName == "div_inner") {
        strarr.push("<div>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</div>");
      } else if (nd.nodeName == "ruby") {
        strarr.push("<ruby><rb>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</rb><rp>(</rp><rt>" + nd.getAttribute("param0") + "</rt><rp>)</rp></ruby>");
      } else if (nd.nodeName == "em") {
        strarr.push("<em>");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</em>");
      } else if (nd.nodeName == "a") {
        strarr.push("<a id=\"" + strid + "\">");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "link") {
        strarr.push("<a href=\"" + nd.getAttribute("param0") + "\">");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "rlink") {
        var strid = nd.getAttribute("param0");
        strarr.push("<a href=\"" + xmlgv.xmlidsection[strid] + "#" + strid + "\">");
        parse_xmlnode_for_section(nd, strarr, xmlgv);
        strarr.push("</a>");
      } else if (nd.nodeName == "image") {
        // param0t@Cparam1LvV擾
        var filename = nd.getAttribute("param0");
        var ffilename = fs.GetParentFolderName(fs.GetAbsolutePathName(option.output_filename)) + "/" + filename;
        var caption = nd.getAttribute("param1");
        
        // 摜TCY擾[eBeBN
//        var cmdline = "getimagesize.exe \"" + filename + "\" \"" + tname + "\""; // WSH5.6ȉ
        var cmdline = getimagesize + " \"" + ffilename + "\"";
        var objExec = sh.Exec(cmdline);
        var w = -1, h = -1;
        if (!objExec.StdOut.AtEndOfStream) {
          w = parseInt(objExec.StdOut.ReadLine());
        }
        if (!objExec.StdOut.AtEndOfStream) {
          h = parseInt(objExec.StdOut.ReadLine());
        }
        // Kvɉĉ摜k
        if (w < option.wmax) { // kȂ
        } else {
          h = parseInt(h * option.wmax / w);
          w = option.wmax;
        }
        str += "<div><a href=\"" + filename + "\"><img ";
        if ((strclass) && (strclass != "")) {
          str += " class=\"" + strclass + "\"";
        }
        if ((strid) && (strid != "")) {
          str += " id=\"" + strid + "\"";
        }
        str += " src=\"" + filename + "\"";
        if ((h > -1) && (w > -1)) {
          str += " width=\"" + w + "\"";
          str += " height=\"" + h + "\"";
        }
        str += " alt=\"" + nd.getAttribute("param1") + "\"";
        str += " /></a></div>";
        strarr.push(str);
      } else {
        // `^O
      }
    } else if (nd.nodeType == 3) { // TEXT_NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/&/g, "&amp;");
      str1 = str1.replace(/</g, "&lt;");
      str1 = str1.replace(/>/g, "&gt;");
      str1 = str1.replace(/ /g, "&nbsp;");
      strarr.push(str1);
    }
  }
  return 0;
}
