/**
 * xml2xml.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/*
 * Usage
 * cscript.exe xml2xml.js -o output_filename [input_filename]
 * -o o̓t@C
 */

// IvVڏݒ
var option = new Object();

// o̓t@C
option.output_filename = "-";

// ̓t@C
option.input_filename = "-";

// IvVځ@܂

// O[oϐ
var fs = new ActiveXObject("Scripting.FileSystemObject");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;
var ForReading = 1;
var ForWriting = 2;

var CRLF = "\n";

do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var tso;

  { // R}hC
    for (var i = 0; i < objArgs.length; ++i) {
      if (objArgs(i) == "-o") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-o.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.output_filename = objArgs(i);
      } else {
        if (i + 1 != objArgs.length) {
          WScript.StdErr.Write(objArgs(i) + ".\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.input_filename = objArgs(i);
      }
    }
  }

  // t@Cǂݍ
  var srcArr = new Array();
  {
    if (option.input_filename != "-") {
      var tsi;
      try {
        tsi = fs.OpenTextFile(option.input_filename, ForReading);
      } catch (e) {
        WScript.StdErr.Write("failed to open input file.\n");
        WScript.Quit(-1);
      }
      while (!tsi.AtEndOfStream) {
        srcArr.push(tsi.ReadLine());
      }
      tsi.Close();
    } else {
      while (!WScript.StdIn.AtEndOfStream) {
        srcArr.push(WScript.StdIn.ReadLine());
      }
    }
  }

  // t@Co
  tso = WScript.StdOut;
  if (option.output_filename != "-") {
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch(e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
  }
  for (var i = 0; i < srcArr.length; ++i) {
    tso.WriteLine(srcArr[i]);
  }
  if (option.output_filename != "-") {
    tso.Close();
  }

  // C[`I
  return 0;
}

